/*
 * Created on 11 jun 2009
 */

package jawnae.js;

import org.mozilla.javascript.Script;

public class JsScript extends JsScope
{
   public JsScript(String code)
   {
      this(code, null);
   }

   JsScript(String code, JsScope scope)
   {
      this(code, scope, "<runtime>", 1);
   }

   public JsScript(String code, JsScope scope, String sourceLocation, int lineOffset)
   {
      super(scope);

      this.code = code;

      try
      {
         this.enterContext();

         this.rhinoScript = this.rhinoContext.compileString(code, sourceLocation, lineOffset, null);
      }
      finally
      {
         this.exitContext();
      }
   }

   //

   private final String code;

   public String getCode()
   {
      return this.code;
   }

   //

   public final Script rhinoScript;

   public Object execute()
   {
      try
      {
         this.enterContext();

         return this.rhinoScript.exec(this.rhinoContext, this.rhinoScope);
      }
      finally
      {
         this.exitContext();
      }
   }

   @Override
   public String toString()
   {
      return "JsScript[" + this.getName() + "]";
   }
}